CON 
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000 
  ' Set pins and Baud rate for XBee comms   
  XB_Rx     = 0    ' XBee DOUT 
  XB_Tx     = 1    ' XBee DIN 
  XB_Baud   = 9600 
  ' Set pins and baud rate for PC comms  
  PC_Rx     = 31   
  PC_Tx     = 30 
  PC_Baud   = 9600
  ServoCh1 = 2                ' Servo to pin 2
  ServoCh2 = 3                ' Servo to pin 3
  ServoCh3 = 4                ' Servo to pin 4
'  ServoCh4 = 5                ' Servo to pin 2
'  ServoCh5 = 6                ' Servo to pin 3
'  ServoCh6 = 7                ' Servo to pin 4 
  dpin =     6                 '74HC595 Data Pin
  cpin =     5                 '74HC595 Clock Pin
  lpin =     7                 '74HC595 Latch Pin
  
con

  #0, CLS, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR   ' PST formmatting control
  MS_001 = 80_000_000 / 1_000 
      
Var 
  long stack[50]                                        ' stack space for second cog 
  long stack2[50]
  long DataIn
                                               
OBJ 
 
  XB    : "XBee_Object"
  SERVO : "Servo32v7.spin"
  PC    : "FullDuplexSerial"
  ADC   : "jm_adc0838_ez"
  SR595 : "jm_595_ez"
  
Pub Start
  PC.start(PC_Rx, PC_Tx, 0, PC_Baud)                    ' Initialize comms for PC         
  XB.start(XB_Rx, XB_Tx, 0, XB_Baud)                    ' Initialize comms for XBee   
  SR595.init(dpin, cpin, lpin)
  dira[16..23]~~
  outa[16..23]~                                   'set I/O pins from cog using the pins                           
'  dira[16..23] := outa[16..23] := 1
  
  cognew(SERVOControl,@stack2)                          ' Start cog for Servo positioning
  SERVO.Start



PUB ServoControl

    SERVO.Start                                         ' Start servo handler

    repeat                                                                                                                      
       DataIn := XB.Rx      
       If DataIn == "A"                                 'Delimiter

        'Sabertooth Channel 1 for Bot Drive 0-127 w/ Center @ 63
             DataIn := XB.rxDec                            'receive data
             DataIn := DataIn / 2
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
             SERVO.Set(ServoCh1, DataIn)

        'Sabertooth Channel 2 for Bot Steering 128-255 w/ Center @ 192 
             DataIn := XB.rxDec                            'receive data
             DataIn := DataIn / 2
             DataIn := DataIn + 127
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
             SERVO.Set(ServoCh1, DataIn)

             
        'Camera Pan                 
             DataIn := XB.rxDec                            'receive data
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
             SERVO.Set(ServoCh3, DataIn)

        'Camera Tilt                               
             DataIn := XB.rxDec                            'receive data
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
         '    SERVO.Set(ServoCh4, DataIn)

        'Parabolic Microphone Pan                               
             DataIn := XB.rxDec                            'receive data
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
         '    SERVO.Set(ServoCh5, DataIn)

        'Parabolic Microphone Tilt                               
             DataIn := XB.rxDec                            'receive data
             ' we'll drive servos based on data later
             PC.tx(CLREOL)
             PC.dec(DataIn)
             PC.tx(CR)
             DataIn := ADC.scale(DataIn, 750, 2250)
          '   SERVO.Set(ServoCh6, DataIn)


        ''74HC165 switch data                              
             DataIn := XB.rxDec                            'receive data
             outa[16..23] := DataIn
             PC.bin(DataIn,8)
             PC.tx(CR)
             SR595.out1(DataIn)
             PC.tx(HOME)